open VecOps

let pi = 4.0 *. atan 1.0

let pi2 = 2.0 *. pi

let clamp low high v = min high (max low v)

let scale low high v =
  float (v - low) /. float (high - low)

let f_scale low high v =
  (v -. low) /. (high -. low)

let ipolate3 v col1 col2 =
  let v = clamp 0.0 1.0 v in
  let s = Vector.v3 v in
  let s'rev = Vector.v3 (1.0 -. v) in
    Vector.int3 (s'rev *||. Vector.float3 col1 +||. s *||. Vector.float3 col2)


let frame_of_radian direction =
  let deg = mod_float (((pi2 -. direction) /. pi2) *. 360.0) 360.0 in
  let deg = if deg < 0.0 then 360.0 +. deg else deg in
  let n = int_of_float (deg /. 10.0 +. 0.5) in
  let n = (n + 9) mod 36 in
    n
      
